#!/bin/bash


#获取当前执行路径
basepath=$(cd `dirname $0`; pwd)


#获取图像
scrot -s -o -f /tmp/GD_eng_ocr_tr.png
if [ $? -ne 0 ]; then
    zenity --error --text "获取图片错误"
    exit
else 
   true
fi


#图片处理
#其它可加参数 -fill white -sharpen 0x1 
convert /tmp/GD_eng_ocr_tr.png -colorspace gray -depth 8 /tmp/GD_eng_ocr_tr.png



#进行OCR

#tesseract引擎
#ocr_txt=$(tesseract -l eng --dpi 300  /tmp/GD_eng_ocr_tr.png stdout quiet)

#tr引擎
#https://github.com/myhub/tr
ocr_txt=$(python "$basepath/tr/GD_ocr.py" | sed '/tr 2.3.1 https:/d' | sed -e "/^ *$/d" | tr '\n' ' ')


#检查是否在运行中
pgrep goldendict | xargs ps -u --pid &>/dev/null
if [ $? -eq 0 ]; then
    #echo "succeed"
    true
else
    echo "try start goldendict"
    goldendict  &> /dev/null &
    sleep 1.5
fi


#排除卡死
timeout 0.4s goldendict "$ocr_txt"
if [ $? -eq 0 ]; then
    #echo "succeed"
    true
else
    echo "try kill goldendict"
    killall goldendict
    goldendict  &> /dev/null &
    sleep 1.5
    goldendict "$ocr_txt"
fi

